various improvements
[distro-setup] / btrbk-run
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7
8 # http://www.apache.org/licenses/LICENSE-2.0
9
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17 # todo: if we cancel in the middle of a btrfs send, then run again immediately, the received subvolume doesn't get a Received UUID: field, and we won't mount it. Need to figure out a solution that will fix this.
18
19 err-bash-trace() {
20 local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
21 local source
22 local extdebug=false
23 if [[ $(shopt -p extdebug) == *-s* ]]; then
24 extdebug=true
25 fi
26 for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
27 argc=${BASH_ARGC[frame]}
28 argc_index+=$argc
29 ((frame < start)) && continue
30 if (( ${#BASH_SOURCE[@]} > 1 )); then
31 source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
32 fi
33 indent=$((frame-start + 1))
34 indent=$((indent < max_indent ? indent : max_indent))
35 printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
36 if $extdebug; then
37 for ((i=argc_index-1; i >= argc_index-argc; i--)); do
38 printf " %s" "${BASH_ARGV[i]}"
39 done
40 fi
41 echo \'
42 done
43 return 0
44 }
45 err-catch() {
46 set -E; shopt -s extdebug
47 _err-trap() {
48 err=$?
49 exec >&2
50 set +x
51 echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
52 err-bash-trace 2
53 set -e # err trap does not work within an error trap
54 "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
55 echo "$0: exiting with code $err"
56 exit $err
57 }
58 trap _err-trap ERR
59 set -o pipefail
60 }
61 err-catch
62
63
64 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
65
66
67 usage() {
68 cat <<'EOF'
69 btrbk-run [OPTIONS]
70 usually -t TARGET_HOST or -s SOURCE_HOST
71
72 Note, at source location, intentionally not executable, run and read
73 install-my-scripts.
74
75 EOF
76 echo "top of script file:"
77 sed -n '1,/^[# ]*end command line/{p;b};q' "$0"
78 exit $1
79 }
80
81 rsync-dirs() {
82 local host=$1
83 local path=$2
84 m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
85 }
86
87
88 m() { if $verbose; then printf "$pre %s\n" "$*"; fi; "$@"; }
89 die() { printf "$pre %s\n" "$*" >&2; exit 1; }
90
91 # latest $MAIL_HOST
92 if [[ -e /b/bash_unpublished/source-state ]]; then
93 source /b/bash_unpublished/source-state
94 fi
95
96 # note q is owned by root:1000
97
98 mountpoints=()
99
100 rsync_mountpoint=/q
101
102 # default options
103 conf_only=false
104 dry_run=false # mostly for testing
105 rate_limit=no
106 verbose=true; verbose_arg=-v
107 progress_arg="--progress"
108 pull_reexec=false
109
110 default_args_file=/etc/btrbk-run.conf
111 if [[ -s $default_args_file ]]; then
112 set -- $(< $default_args_file) "$@"
113 # i havent used this feature yet, so warn about it
114 echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
115 cat $default_args_file
116 sleep 5
117 fi
118
119 pre="${0##*/}:"
120 cron=false
121 orig_args=("$@")
122 temp=$(getopt -l cron,pull-reexec,help cl:m:npqs:t:vh "$@") || usage 1
123 eval set -- "$temp"
124 while true; do
125 case $1 in
126 --cron)
127 cron=true
128 pre=
129 shift
130 ;;
131 # only creates the config file, does not run btrbk
132 -c) conf_only=true; shift ;;
133 # bytes per second, suffix k m g
134 -l) rate_limit=$2; shift 2 ;;
135 # Comma separated mountpoints to backup. This has defaults set below.
136 -m) IFS=, mountpoints=($2); unset IFS; shift 2 ;;
137 -n) dry_run=true; dry_run_arg=-n; shift ;;
138 -p) progress_arg="--progress"; shift ;;
139 --pull-reexec) pull_reexec=true; shift ;;
140 -q) verbose=false; verbose_arg=; progress_arg=; shift ;;
141 # source host to receive a backup from
142 -s) source=$2; shift 2 ;;
143 # target hosts to send to. empty is valid for just doing local
144 # snapshot. we have default hosts we will populate.
145 -t) IFS=, targets=($2); unset IFS; shift 2 ;;
146 -v) verbose=true; verbose_arg=-v; shift ;;
147 -h|--help) usage ;;
148 --) shift; break ;;
149 *) die "Internal error!" ;;
150 esac
151 done
152
153 # only tested commands are resume and archive
154 cmd_arg=${1:-run}
155
156 case $cmd_arg in
157 run|resume|archive) : ;;
158 *) die "untested command arg" ;;
159 esac
160
161 if (( $# > 1 )); then
162 die: "only 1 nonoption arg is supported"
163 fi
164
165 if [[ -v targets && $source ]]; then
166 die "error: -t and -s are mutually exclusive"
167 fi
168
169 if $verbose; then
170 printf "$pre options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
171 fi
172 ### end options parsing
173
174 # TODO: i wonder if there should be an option to send to the default
175 # targets, plus any given on the command line.
176
177 # set default targets
178 if [[ ! -v targets && ! $source ]]; then
179 if [[ $HOSTNAME != "$MAIL_HOST" ]] && $cron ; then
180 echo "MAIL_HOST=$MAIL_HOST, nothing to do"
181 exit 0
182 fi
183 case $HOSTNAME in
184 kw|x2)
185 if ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
186 home=iank.vpn.office.fsf.org
187 else
188 home=b8.nz
189 fi
190 ;;&
191 kw)
192 targets=($home x2)
193 ;;
194 x2)
195 targets=($home kw)
196 ;;
197 tp)
198 targets=(frodo kd)
199 # might not be connected to the vpn
200 if timeout -s 9 10 ssh kw :; then
201 targets+=(kw)
202 fi
203 ;;
204 kd)
205 targets=(frodo tp)
206 # might not be connected to the vpn
207 if timeout -s 9 10 ssh kw :; then
208 targets+=(kw)
209 fi
210 ;;
211 *)
212 die "error: no default targets for this host, use -t"
213 ;;
214 esac
215 fi
216
217 if [[ -v targets ]]; then
218 echo "targets: ${targets[*]}"
219 fi
220
221 if [[ $source ]]; then
222 echo "source: $source"
223 fi
224
225
226 if [[ $mountpoints ]]; then
227 for mp in ${mountpoints[@]}; do # default mountpoints to sync
228 if [[ -e /nocow/btrfs-stale/$mp ]]; then
229 die "error: $mp is stale, mount-latest-subvol first"
230 fi
231 done
232 else
233 # set default mountpoints
234 case $HOSTNAME in
235 # no remote backups atm. note, if we do enable this, configuration below will need some changes.
236 # frodo)
237 # prospective_mps=(/i)
238 # ;;
239 *)
240 prospective_mps=(/a /q)
241 if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
242 prospective_mps+=(/o)
243 fi
244 ;;
245 esac
246 for mp in ${prospective_mps[@]}; do # default mountpoints to sync
247 if [[ -e /nocow/btrfs-stale/$mp ]]; then
248 echo "$pre warning: $mp stale, not adding to default mountpoints"
249 continue
250 fi
251 if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
252 mountpoints+=($mp)
253 fi
254 done
255 fi
256
257 echo "mountpoints: ${mountpoints[*]}"
258
259 ##### end command line parsing ########
260
261 if [[ $source ]]; then
262 if [[ $(ssh $source systemctl is-active btrbk.service) != inactive ]]; then
263 echo "$0: error: cron btrbk is running on source. exiting out of caution"
264 exit 1
265 fi
266 fi
267
268 # pull_reexec stops us from getting into an infinite loop if there is some
269 # kind of weird problem
270 pulla=false
271 for m in "${mountpoints[@]}"; do
272 if [[ $m == /a ]]; then
273 pulla=true
274 break
275 fi
276 done
277 if ! $pull_reexec && [[ $source ]] && $pulla ; then
278 tmpf=$(mktemp)
279 scp $source:/a/bin/distro-setup/btrbk-run $tmpf
280 if ! diff -q $tmpf $BASH_SOURCE; then
281 echo "$pre found newer version on host $source. reexecing"
282 install -T $tmpf /usr/local/bin/btrbk-run
283 m /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
284 exit
285 fi
286 fi
287
288
289
290
291
292 if ! which btrbk &>/dev/null; then
293 die "error: no btrbk binary found"
294 fi
295 # if our mountpoints are from stale snapshots,
296 # it doesn't make sense to do a backup.
297 check-subvol-stale ${mountpoints[@]} || die "found stale mountpoints in ${mountpoints[*]}"
298
299 # for an initial run, btrbk requires the dir to exist.
300 mkdir -p /mnt/root/btrbk
301 local_zone=$(date +%z)
302
303 if [[ $source ]]; then
304 if ! zone=$(ssh root@$source date +%z); then
305 die failed to ssh to root@$source
306 fi
307 if [[ $zone != $local_zone ]]; then
308 die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
309 fi
310
311 else
312
313 sshable=()
314 sshfail=()
315 min_idle_ms=$((1000 * 60 * 15))
316 for h in ${targets[@]}; do
317 if zone=$(ssh root@$h "mkdir -p /mnt/root/btrbk && date +%z"); then
318 if $cron && DISPLAY=:0 xprintidle; then
319 # This is a separate ssh because xprintidle can fail and thats ok.
320 # Ignore this host. i sometimes use a non-main machine for testing or web browsing, knowing that
321 # everything will be wiped by the next backup, but I dont want it to happen as Im using
322 # it from cronjob.
323 continue
324 fi
325 sshable+=($h)
326 if [[ $zone != $local_zone ]]; then
327 die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
328 fi
329 else
330 sshfail+=($h)
331 fi
332 done
333 if [[ ! $sshable ]] || { ! $cron && [[ $sshfail ]]; }; then
334 die "failed to ssh to hosts: ${sshfail[*]}"
335 else
336 if [[ $sshfail ]]; then
337 ret=1
338 echo "$pre error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
339 fi
340 targets=(${sshable[@]})
341 fi
342 fi
343
344
345 cat >/etc/btrbk.conf <<EOF
346 ssh_identity /root/.ssh/home
347 # Just a guess that local7 is a good facility to pick.
348 # It's a bit odd that the transaction log has to be logged to
349 # a file or syslog, while other output is sent to std out.
350 # The man does not mention a way for them to be together, but
351 # I dunno if setting a log level like warn might also output
352 # transaction info.
353 transaction_syslog local7
354
355 # note, i had this because man said 20% speedup, but ran into
356 # this issue, https://github.com/digint/btrbk/issues/275
357 #stream_buffer 512m
358
359 # so we only run one at a time
360 lockfile /var/lock/btrbk.lock
361
362 # default format of short does not accomidate hourly preservation setting
363 timestamp_format long-iso
364
365 # only make a snapshot if things have changed
366 snapshot_create onchange
367 # I could make this different from target_preserve,
368 # if one disk had less space.
369 # for now, keeping them equal.
370 snapshot_preserve 36h 14d 8w 24m
371 snapshot_preserve_min 4h
372 snapshot_dir btrbk
373
374 # so, total backups = ~89
375 target_preserve 36h 14d 8w 24m
376 target_preserve_min 4h
377
378 # if something fails and it's not obvious, try doing
379 # btrbk -l debug -v dryrun
380
381 rate_limit $rate_limit
382 EOF
383
384
385
386
387
388 vol=/mnt/root
389 for m in ${mountpoints[@]}; do
390 sub=${m##*/}
391 if [[ $source ]]; then
392 cat >>/etc/btrbk.conf <<EOF
393 volume ssh://$source$vol
394 subvolume $sub
395 target send-receive $vol/btrbk
396 EOF
397 else
398 cat >>/etc/btrbk.conf <<EOF
399 volume $vol
400 subvolume $sub
401 EOF
402 for tg in ${targets[@]}; do
403 cat >>/etc/btrbk.conf <<EOF
404 target send-receive ssh://$tg$vol/btrbk
405 EOF
406 done
407 fi
408 done
409
410
411 # todo: umount first to ensure we don't have any errors
412 # todo: do some kill fuser stuff to make umount more reliable
413
414
415 if $conf_only; then
416 exit
417 fi
418
419
420
421 if $dry_run; then
422 m btrbk -v -n $cmd_arg
423 exit 0
424 elif [[ $cmd_arg == archive ]]; then
425 if [[ $source ]]; then
426 m btrbk $verbose_arg $progress_arg $cmd_arg ssh://$source$vol $vol
427 else
428 for tg in ${targets[@]}; do
429 m btrbk $verbose_arg $progress_arg $cmd_arg $vol ssh://$tg$vol
430 done
431 fi
432 exit 0
433 fi
434 # -q and just using the syslog option seemed nice,
435 # but it doesn't show when a send has a parent and when it doesn't.
436 m btrbk $verbose_arg $progress_arg $cmd_arg
437
438 # if we have it, sync to systems which don't
439 if mountpoint $rsync_mountpoint >/dev/null; then
440 for tg in ${targets[@]}; do
441 case $tg in
442 li|lk)
443 for x in /p/c/machine_specific/*.hosts; do
444 if grep -qxF $tg $x; then
445 dir=${x%.hosts}
446 rsync-dirs $tg $dir
447 fi
448 done
449 ;;
450 esac
451 done
452 fi
453
454 if [[ $source ]]; then
455 m mount-latest-subvol $verbose_arg
456 else
457 m /a/exe/mount-latest-remote ${targets[@]}
458 fi
459
460 exit $ret
461
462 # todo: move variable data we don't care about backing up
463 # to /nocow and symlink it.
464
465
466 # background on btrbk timezones. with short/long, timestamps use local time.
467 # for long, if your local time moves backwards, by moving timezones or
468 # for an hour when daylight savings changes it, you will temporarily get
469 # a more aggressive retention policy for the overlapping period, and
470 # vice versa for the opposite timezone move. The alternative is using
471 # long-iso, which puts timezone info into the timestamp, which means
472 # that instead of shifting time, you shift the start of day/week/month
473 # which is used for retention to your new local time, which means for
474 # example, if you moved forward by 8 hours, the daily/weekly/monthly
475 # retention will be 8 hours more aggressive since midnight is at a new
476 # time, unless you fake the timzeone using the TZ env variable.
477 # However, in the short term, there will be no inconsistencies.
478 # I don't see any problem with shifting when the day starts for
479 # retention, so I'm using long-iso.
480
481 # note to create a long-iso timestamp: date +%Y%m%dT%H%M%S%z